;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              #include <P16F628A.INC>
              LIST        p=16F628A     
              __CONFIG    H'3F10'           ; 
                                               
              errorlevel  -302              ;     302  

Sec           equ         0020h             ;  
Sec1          equ         0021h             ;
Sec2          equ         0022h             ;
scetbit       equ         0024h             ;   -   
perem         equ         0025h             ;  /   
tmp           equ         0026h             ;           
                                            ;
lcd_tmp       equ         0027h             ;   
                                            ;
adr_i2c       equ         0028h             ;     i2c
tmp_i2c       equ         0029h             ;
slave_adr     equ         002Ah             ;
data_i2c      equ         002Bh             ;
                                            ;
flag          equ         007Fh             ; 

#DEFINE       sda         PORTB,0           ; sda I2C
#DEFINE       scl         PORTB,1           ; scl I2C
#DEFINE       sda_io      TRISB,0           ; sda I2C
#DEFINE       scl_io      TRISB,1           ; scl I2C
#DEFINE       knp_led     PORTB,2           ; / 
#DEFINE       led         PORTB,3           ;  i2c

;flag,2 -    (0 - , 1 - )
;flag,3 -   / (0 - , 1 - )
;flag,4 -    (0 - , 1 - )
;flag,5 -      
;flag,6 -      I2C (   )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         movlw       b'00000000'       ;     B     
              movwf       PORTB             ; 
                                            ;
              movlw       b'00000111'       ; 
              movwf       CMCON             ;
                                            ;
              bsf         STATUS,RP0        ; 1-     
              movlw       b'11110111'       ;  \  B      
              movwf       TRISB             ;RB3 -  ,                                
              bcf         STATUS,RP0        ; 0-  
                                            ;
              clrf        flag              ;   
                                            ;
              call        lcd_led_on        ;   
                                            ;
              call        init_lcd          ;   
              call        err_prov          ; 
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              
              movlw       0x02              ;  DDRAM  (1-  3- )
              call        lcd_adr           ;    DDRAM

              movlw       'R'               ;  RadioLaba.ru
              call        lcd_dat           ;
              movlw       'a'               ;
              call        lcd_dat           ;
              movlw       'd'               ;
              call        lcd_dat           ;
              movlw       'i'               ;
              call        lcd_dat           ;
              movlw       'o'               ;
              call        lcd_dat           ;
              movlw       'L'               ;
              call        lcd_dat           ;
              movlw       'a'               ;
              call        lcd_dat           ;
              movlw       'b'               ;
              call        lcd_dat           ;
              movlw       'a'               ;
              call        lcd_dat           ;
              movlw       '.'               ;
              call        lcd_dat           ;
              movlw       'r'               ;
              call        lcd_dat           ;
              movlw       'u'               ;
              call        lcd_dat           ;
                                            ;
              call        paus              ; 1 
                                            ;
              movlw       0x43              ;  DDRAM  (2-  4- )
              call        lcd_adr           ;    DDRAM
                                            ;
              movlw       'L'               ;  LCD 1602A
              call        lcd_dat           ;
              movlw       'C'               ;
              call        lcd_dat           ;
              movlw       'D'               ;
              call        lcd_dat           ;
              movlw       ' '               ;
              call        lcd_dat           ;
              movlw       '1'               ;
              call        lcd_dat           ;
              movlw       '6'               ;
              call        lcd_dat           ;
              movlw       '0'               ;
              call        lcd_dat           ;
              movlw       '2'               ;
              call        lcd_dat           ;
              movlw       'A'               ;
              call        lcd_dat           ;
                                            ;
              call        paus              ; 1 
              call        paus              ; 1 
                                            ;
              movlw       .16               ;    16 
              movwf       tmp               ;
met_1         movlw       b'00011000'       ;   
              call        lcd_comm          ;   
              decfsz      tmp,F             ;
              goto        met_1             ;

              movlw       0x13              ;  DDRAM  (1-  20- )
              call        lcd_adr           ;    DDRAM

              movlw       'P'               ;  PCF8574AT
              call        lcd_dat           ;
              movlw       'C'               ;
              call        lcd_dat           ;
              movlw       'F'               ;
              call        lcd_dat           ;
              movlw       '8'               ;
              call        lcd_dat           ;
              movlw       '5'               ;
              call        lcd_dat           ;
              movlw       '7'               ;
              call        lcd_dat           ;
              movlw       '4'               ;
              call        lcd_dat           ;
              movlw       'A'               ;
              call        lcd_dat           ;
              movlw       'T'               ;
              call        lcd_dat           ;
                                            ;
              call        paus              ; 1 
                                            ;
              movlw       0x54              ;  DDRAM  (2-  21- )
              call        lcd_adr           ;    DDRAM
                                            ;
              movlw       'I'               ;  I2C bus
              call        lcd_dat           ;
              movlw       '2'               ;
              call        lcd_dat           ;
              movlw       'C'               ;
              call        lcd_dat           ;
              movlw       ' '               ;
              call        lcd_dat           ;
              movlw       'b'               ;
              call        lcd_dat           ;
              movlw       'u'               ;
              call        lcd_dat           ;
              movlw       's'               ;
              call        lcd_dat           ;
                                            ;
              call        paus              ; 1 
              call        paus              ; 1 
                                            ;
sdvig         movlw       .16               ;    16      
              movwf       tmp               ;  10 
sdvig_1       movlw       b'00011100'       ;   
              call        lcd_comm          ;   
              call        knp_opros         ;    
              movlw       .100              ;
              call        paus_lcd          ; 100 
              decfsz      tmp,F             ;
              goto        sdvig_1           ;

              movlw       .20               ; 2        10 
              movwf       tmp               ;
sdvig_2       call        knp_opros         ;    
              movlw       .100              ;
              call        paus_lcd          ; 100 
              decfsz      tmp,F             ;
              goto        sdvig_2           ;

              movlw       .16               ;    16      
              movwf       tmp               ;  10 
sdvig_3       movlw       b'00011000'       ;   
              call        lcd_comm          ;   
              call        knp_opros         ;    
              movlw       .100              ;
              call        paus_lcd          ; 100 
              decfsz      tmp,F             ;
              goto        sdvig_3           ;    

              movlw       .20               ; 2        10 
              movwf       tmp               ;
sdvig_4       call        knp_opros         ;    
              movlw       .100              ;
              call        paus_lcd          ; 100 
              decfsz      tmp,F             ;
              goto        sdvig_4           ;
              goto        sdvig             ;   sdvig

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

knp_opros     btfsc       knp_led           ;    
              return                        ;  :   
              call        paus_knp          ; ,  
              btfss       knp_led           ;
              goto        $-2               ;
                                            ;
              btfsc       flag,2            ;   
              goto        knp_1             ;
              call        lcd_led_on        ; :    
              return                        ;  
                                            ;
knp_1         call        lcd_led_off       ; :    
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              
err_prov      btfss       flag,6            ;    I2C
              return                        ; :    
err_1         bsf         led               ;:   led
              goto        err_1             ;   err_1:  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; /  

lcd_led_on    movlw       b'00001000'       ;   3-   1
              movwf       adr_i2c           ;
              bsf         flag,2            ;    
              goto        lcd_led_1         ;

lcd_led_off   movlw       b'00000000'       ;   3-   0
              movwf       adr_i2c           ;
              bcf         flag,2            ;    
lcd_led_1     movlw       b'01111110'       ;
              movwf       slave_adr         ;   PCF8574AT   slave_adr
              clrf        tmp_i2c           ;
              call        write_i2c         ;     i2c
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   LCD 1602

init_lcd      movlw       .15               ; 15 
              call        paus_lcd          ;
              movlw       b'00110000'       ;  0011 ( )
              call        lcd_comm_1        ;      
              btfsc       flag,6            ; 
              return                        ;
 
              movlw       .5                ; 5 
              call        paus_lcd          ;
              movlw       b'00110000'       ;  0011 ( )
              call        lcd_comm_1        ;      
              btfsc       flag,6            ; 
              return                        ;
          
              movlw       .1                ; 1 
              call        paus_lcd          ;
              movlw       b'00110000'       ;  0011 ( )
              call        lcd_comm_1        ;      
              btfsc       flag,6            ; 
              return                        ;

                                            ;  0010 ( )
              movlw       b'00100000'       ; 4-  
              call        lcd_comm_1        ;      
              btfsc       flag,6            ; 
              return                        ;

                                            ;  00101000
              movlw       b'00101000'       ; 4-  ,  2  ,  5x8
              call        lcd_comm          ;      
              btfsc       flag,6            ; 
              return                        ;

                                            ;  00001000
              movlw       b'00001000'       ; ,  ,   
              call        lcd_comm          ;      
              btfsc       flag,6            ; 
              return                        ;
                                          
              movlw       b'00000001'       ;    00000001
              call        lcd_comm          ;      
              btfsc       flag,6            ; 
              return                        ;

                                            ;  00000110
              movlw       b'00000110'       ;  -  ( ),   
              call        lcd_comm          ;      
              btfsc       flag,6            ; 
              return                        ;

                                            ;  00001100
              movlw       b'00001100'       ; ,  ,   
              call        lcd_comm          ;      
              return                        ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     

lcd_comm_1    movwf       lcd_tmp           ;
              movlw       b'01111110'       ;
              movwf       slave_adr         ;   PCF8574AT   slave_adr

              movlw       b'11110000'       ;  ,  E=1
              andwf       lcd_tmp,W         ;
              movwf       adr_i2c           ;
              movlw       b'00000100'       ;
              iorwf       adr_i2c,F         ;
              btfsc       flag,2            ;   
              bsf         adr_i2c,3         ; =1,  

              movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              movlw       b'11110000'       ;  ,  E=0
              andwf       lcd_tmp,W         ;
              movwf       INDF              ;
              btfsc       flag,2            ;   
              bsf         INDF,3            ; =1,  
    
              movlw       .1                ; 1-   i2c
              movwf       tmp_i2c           ;
              call        write_i2c         ;     i2c
              return                        ;  
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       (1 )

lcd_adr       movwf       lcd_tmp           ;  
              bsf         lcd_tmp,7         ; 7- , 
              bcf         flag,3            ; ,  
              goto        lcd_met_1         ;

lcd_cgram     movwf       lcd_tmp           ;   CGRAM 
              bcf         lcd_tmp,7         ; 7- ,  6-  
              bsf         lcd_tmp,6         ;
              bcf         flag,3            ; ,  
              goto        lcd_met_1         ;

lcd_dat       movwf       lcd_tmp           ;    
              bsf         flag,3            ; ,  
              goto        lcd_met_1         ;
lcd_comm      movwf       lcd_tmp           ;    
              bcf         flag,3            ; ,  

lcd_met_1     movlw       b'01111110'       ;
              movwf       slave_adr         ;   PCF8574AT   slave_adr
              
              movlw       b'11110000'       ;  ,  E=1
              andwf       lcd_tmp,W         ;    RS=0
              movwf       adr_i2c           ;    RS=1
              btfsc       flag,3            ;
              movlw       b'00000101'       ;
              btfss       flag,3            ;
              movlw       b'00000100'       ;
              iorwf       adr_i2c,F         ;
              btfsc       flag,2            ;   
              bsf         adr_i2c,3         ; =1,  
              
              movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              movlw       b'11110000'       ;  ,  E=0
              andwf       lcd_tmp,W         ;    RS=0
              movwf       INDF              ;    RS=1
              btfss       flag,3            ;
              goto        lcd_met_2         ;
              movlw       b'00000001'       ;
              iorwf       INDF,F            ;

lcd_met_2     incf        FSR,F             ;  FSR
              swapf       lcd_tmp,F         ;  
              movlw       b'11110000'       ;  ,  E=1
              andwf       lcd_tmp,W         ;    RS=0
              movwf       INDF              ;    RS=1
              btfsc       flag,3            ;
              movlw       b'00000101'       ;
              btfss       flag,3            ;
              movlw       b'00000100'       ;
              iorwf       INDF,F            ;

              incf        FSR,F             ;  FSR
              movlw       b'11110000'       ;  ,  E=0
              andwf       lcd_tmp,W         ;    RS=0
              movwf       INDF              ;    RS=1
              btfss       flag,3            ;
              goto        lcd_met_3         ;
              movlw       b'00000001'       ;
              iorwf       INDF,F            ;

lcd_met_3     btfss       flag,2            ;   
              goto        lcd_met_4         ; =0,  ,   

              movlw       data_i2c          ;   /  i2c
              movwf       FSR               ;
              bsf         INDF,3            ; =1,  
              incf        FSR,F             ;
              bsf         INDF,3            ;
              incf        FSR,F             ;
              bsf         INDF,3            ;

lcd_met_4     movlw       .3                ; 3-   i2c
              movwf       tmp_i2c           ;
              call        write_i2c         ;     i2c
              
              btfsc       flag,3            ;   
              return                        ;      
              swapf       lcd_tmp,F         ;  
              movlw       .1                ;   
              xorwf       lcd_tmp,W         ;
              btfsc       STATUS,Z          ;
              goto        lcd_met_5         ;      lcd_met_5
              movlw       b'11111110'       ;    
              andwf       lcd_tmp,W         ;
              xorlw       .2                ;
              btfss       STATUS,Z          ;
              return                        ;      
lcd_met_5     movlw       .2                ;   
              call        paus_lcd          ;   2 
              return                        ;      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; /   I2C

write_i2c     bsf         flag,4            ;    ( )
              goto        i2c_1             ;   i2c_1
read_i2c      bcf         flag,4            ;    ( )
              bcf         flag,5            ;    
i2c_1         bcf         flag,6            ;   I2C
              call        starti2c          ;  ""
            
              bcf         slave_adr,0       ;  R/W   
              movf        slave_adr,W       ;  
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              movf        adr_i2c,W         ;   I2C
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:    err_i2c
                      
              movlw       .0                ; -  
              xorwf       tmp_i2c,W         ;
              btfss       STATUS,Z          ;
              goto        i2c_3             ;-     0:    i2c_3
              call        stopi2c           ;-    0:   ""
              return                        ;   / I2C

i2c_3         movlw       data_i2c          ;      
              movwf       FSR               ;   
              decf        FSR,F             ;

              btfss       flag,4            ;   
              goto        rd_i2c            ;  0:    rd_i2c ()

i2c_2         incf        FSR,F             ;  FSR,     
              movf        INDF,W            ;    
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:    err_i2c

              decfsz      tmp_i2c,F         ;  -  
              goto        i2c_2             ;   0:    i2c_2
              call        stopi2c           ;  ""
              return                        ;   / I2C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rd_i2c        call        starti2c          ;  "" ( )
              bsf         slave_adr,0       ;  R/W   
              movf        slave_adr,W       ;  
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:    err_i2c

rd_i2c_2      decfsz      tmp_i2c,F         ;  -  
              goto        rd_i2c_1          ;   0:    rd_i2c_1
              bsf         flag,5            ;      
rd_i2c_1      incf        FSR,F             ;  FSR,      
              call        priemi2c          ;   
            
              movwf       INDF              ;     INDF
              btfss       flag,5            ;      
              goto        rd_i2c_2          ;   0:    rd_i2c_2
              call        stopi2c           ;  ""
              return                        ;   / I2C

err_i2c       call        stopi2c           ;  "" 
              return                        ;   / I2C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

starti2c      call        scl_1             ;  scl
              call        pausi2c           ;  
              call        sda_0             ;  0  sda
              call        pausi2c           ;  
              call        scl_0             ;  0  scl
              call        pausi2c           ;  
              return                        ;  

stopi2c       call        sda_0             ;  0  sda
              call        pausi2c           ;  
              call        scl_1             ;  scl
stpi2c_1      call        pausi2c           ;  
              btfss       scl               ;  SCL   
              goto        stpi2c_1          ; :    stpi2c_1
              call        sda_1             ;  sda
              call        pausi2c           ;  
              return                        ;  

sda_1         bsf         STATUS,RP0        ;  sda  
              bsf         sda_io            ;        
              bcf         STATUS,RP0        ;
              return                        ;  

sda_0         bcf         sda               ;  sda  
              bsf         STATUS,RP0        ;
              bcf         sda_io            ;
              bcf         STATUS,RP0        ;
              return                        ;  

scl_1         bsf         STATUS,RP0        ;  scl  
              bsf         scl_io            ;        
              bcf         STATUS,RP0        ;
              return                        ;  

scl_0         bcf         scl               ;  scl  
              bsf         STATUS,RP0        ;
              bcf         scl_io            ;
              bcf         STATUS,RP0        ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     i2c

peredi2c      movwf       perem             ;     perem
              movlw       .8                ;  
              movwf       scetbit           ;
prd_i2c_1     btfsc       perem,7           ;    
              call        sda_1             ;  sda
              btfss       perem,7           ;    
              call        sda_0             ;  0  sda
              call        scl_1             ;  scl
prd_i2c_2     call        pausi2c           ;  
              btfss       scl               ;  SCL   
              goto        prd_i2c_2         ; :    prd_i2c_2
              call        scl_0             ;  0  scl
              call        pausi2c           ;  
              rlf         perem,F           ;   perem,    
              decfsz      scetbit,F         ;  
              goto        prd_i2c_1         ;   0:    prd_i2c_1
            
              call        sda_1             ;  sda
              call        scl_1             ;  scl
prd_i2c_3     call        pausi2c           ;  
              btfss       scl               ;  SCL   
              goto        prd_i2c_3         ; :    prd_i2c_3

              movlw       .20               ;   (100 )   
              movwf       scetbit           ;
prd_i2c_4     btfss       sda               ;  sda	
              goto        prd_i2c_5         ;   sda,  :   prd_i2c_5
              decfsz      scetbit,F         ;   sda,   
              goto        prd_i2c_4         ;   0:    prd_i2c_4
              bsf         flag,6            ;  0,  ,    
prd_i2c_5     call        scl_0             ;  0  scl
              call        pausi2c           ;  
              return                        ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     i2c

priemi2c      movlw       .8                ;  
              movwf       scetbit           ;
              call        sda_1             ;  sda
prm_i2c_1     rlf         perem,F           ;   perem,     
              call        scl_1             ;  scl
prm_i2c_2     call        pausi2c           ;  
              btfss       scl               ;  SCL   
              goto        prm_i2c_2         ; :    prm_i2c_2
              btfsc       sda               ;  sda
              bsf         perem,0           ; 0-   perem,  =1
              btfss       sda               ;  sda
              bcf         perem,0           ; 0-   perem,  =0
              call        scl_0             ;  0  scl
              call        pausi2c           ;  
              decfsz      scetbit,F         ;  
              goto        prm_i2c_1         ;   0:    prm_i2c_1
 
              btfss       flag,5            ;      
              call        sda_0             ;  0,   ,   0  sda ()

              call        scl_1             ;  scl
prm_i2c_3     call        pausi2c           ;  
              btfss       scl               ;  SCL   
              goto        prm_i2c_3         ; :    prm_i2c_3
              call        scl_0             ;  0  scl
              call        pausi2c           ;  
              movf        perem,W           ;    
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  5  

pausi2c       nop                           ; 
              return                        ;   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                  
paus_lcd      movwf       Sec2              ;   1-255 
p_l3          movlw       .2                ;
              movwf       Sec1              ;
p_l2          movlw       .166              ;
              movwf       Sec               ;
p_l1          decfsz      Sec,F             ;
              goto        p_l1              ;
              decfsz      Sec1,F            ;
              goto        p_l2              ;
              decfsz      Sec2,F            ;
              goto        p_l3              ;
              return                        ;  

paus_knp      movlw       .20               ;  15 
              movwf       Sec1              ;
pa_l2         movlw       .255              ;
              movwf       Sec               ;
pa_l1         decfsz      Sec,F             ;
              goto        pa_l1             ;
              decfsz      Sec1,F            ;
              goto        pa_l2             ;
              return                        ;  

paus          movlw       .5                ;  1 
              movwf       Sec2              ;
pb_l3         movlw       .255              ;
              movwf       Sec1              ;
pb_l2         movlw       .255              ;
              movwf       Sec               ;
pb_l1         decfsz      Sec,F             ;
              goto        pb_l1             ;
              decfsz      Sec1,F            ;
              goto        pb_l2             ;
              decfsz      Sec2,F            ;
              goto        pb_l3             ;
              return                        ;  


              end                           ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
